
# line 2 "hpgl.y"
/*****************************************************************\
 * FILE: hpgl.y   part of hpgl to X windows                      *
 *                                                               *
 * Written by Randy L. Yach aid by Jackie Harrison               *
 * Ported to X11R4 by Andrew Gerber gerber@solbourne.com         *
 *                  Lex & Yacc info from Warner Losh             *
 *                                                               *
 * Description:                                                  *
 *    this is the yacc parser of HPGL syntax.  All plotting      *
 *    line drawing and labeling are done in this procedure       *
\*****************************************************************/

#include <stdio.h>
#include <X11/X.h>
#include <X11/Xlib.h>
#include <math.h>

/* need all these external global variables to interface with the many
   X windows variables. */
extern int hline;
extern char yytext[];
extern double xMin,xMax,yMin,yMax;
extern int last_x, last_y;
extern int x,y;
extern int cur_pen,no_pen;
extern int pen_down;
extern int absolute;
extern XColor pen[];
extern Window main_window;
extern Font text_font;
extern short font_offset;
extern int minWidth,minHeight;
extern line;
extern GC gc;
extern Display *dpy;
XTextItem text;
extern int span_count;
extern int is_color;
extern initialize_plotter();
extern int offscreen, last_offscreen;

/* binary pattern definitions for drawing dashed lines */
/* default |________|  */
/* line 0  |        |  */
/* line 1  |_       |  */
/* line 2  |____    |  */
/* line 3  |______  |  */
/* line 4  |______ _|  */
/* line 5  |_____ __|  */
/* line 6  |____ _ _|  */
unsigned short line_pattern[7] = {
    0x00, 0x80, 0xf0, 0xfc, 0xfd, 0xfb, 0xf5
    };

/* these variables are needed to calculate the default length
   of the patterns used in the dashed lines */
int pat_len;
double pat_perc,tot_dist;


# line 67 "hpgl.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
int i;
char sb[BUFSIZ];
float f;
} YYSTYPE;
# define LT 257
# define LB 258
# define PA 259
# define PR 260
# define PU 261
# define PD 262
# define SP 263
# define SC 264
# define DIGIT 265
# define SEMICOLON 266
# define COMMA 267
# define NUMBER 268
# define RESET 269
# define EA 270
# define EAT_TO_SEMI 271
# define RA 272

#include <malloc.h>
#include <memory.h>
#include <unistd.h>
#include <values.h>

#ifdef __cplusplus

#ifndef yyerror
	void yyerror(const char *);
#endif
#ifndef yylex
	extern "C" int yylex(void);
#endif
	int yyparse(void);

#endif
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 221 "hpgl.y"

void yyerror(mess)
char *mess;
{ 
/* begin parsing error */
    fprintf(stderr,"Syntax error line %d token %s.\n",hline,yytext); 
/* end parsing error */
/*     exit();  */
} 

int yywrap()
{ /* begin */
	return(1);
} /* end */

yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 25
# define YYLAST 44
yytabelem yyact[]={

     7,    13,     9,    12,    11,    10,     4,     5,    37,    35,
    33,    30,     8,    32,    29,    27,    25,    23,    16,    26,
    24,    16,    38,    36,    34,    31,    20,    18,    15,    28,
    22,    19,     6,    17,    14,     3,     2,     1,     0,     0,
     0,     0,     0,    21 };
yytabelem yypact[]={

-10000000,  -257,-10000000,-10000000,  -245,  -238,-10000000,  -239,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,  -248,-10000000,-10000000,  -246,  -251,  -247,
  -252,-10000000,  -253,  -256,-10000000,  -240,-10000000,  -255,-10000000,-10000000,
  -241,  -258,-10000000,-10000000,-10000000,  -242,  -259,  -243,-10000000 };
yytabelem yypgo[]={

     0,    37,    36,    28,    35,    34,    33,    32,    31,    30,
    29 };
yytabelem yyr1[]={

     0,     1,     1,     3,     3,     2,     2,     2,     2,     2,
     2,     8,     8,     8,     7,     4,     4,     4,     4,     6,
     5,     5,    10,    10,     9 };
yytabelem yyr2[]={

     0,     0,     4,     2,     0,     6,     5,     6,     2,     6,
     3,     1,     7,     7,     3,     3,     3,     3,     3,    15,
     0,     6,     0,     2,     7 };
yytabelem yychk[]={

-10000000,    -1,    -2,    -4,   263,   264,    -7,   257,   269,   259,
   262,   261,   260,   258,    -5,    -3,   266,    -6,   265,    -8,
   265,    -3,    -9,   265,   266,   267,   266,   267,   -10,   267,
   267,   265,   268,   265,   265,   267,   265,   267,   265 };
yytabelem yydef[]={

     1,    -2,     2,    20,     4,     0,     8,    11,    10,    15,
    16,    17,    18,    14,     4,     6,     3,     0,     0,     0,
     0,     5,    22,     0,     7,     0,     9,     0,    21,    23,
     0,     0,    12,    13,    24,     0,     0,     0,    19 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"LT",	257,
	"LB",	258,
	"PA",	259,
	"PR",	260,
	"PU",	261,
	"PD",	262,
	"SP",	263,
	"SC",	264,
	"DIGIT",	265,
	"SEMICOLON",	266,
	"COMMA",	267,
	"NUMBER",	268,
	"RESET",	269,
	"EA",	270,
	"EAT_TO_SEMI",	271,
	"RA",	272,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"xhpgl_start : /* empty */",
	"xhpgl_start : xhpgl_start xhpgl_commands",
	"opt_semicolon : SEMICOLON",
	"opt_semicolon : /* empty */",
	"xhpgl_commands : plot_coordinates cordinate_list opt_semicolon",
	"xhpgl_commands : SP opt_semicolon",
	"xhpgl_commands : SC scale_coordinates SEMICOLON",
	"xhpgl_commands : text_labels",
	"xhpgl_commands : LT line_type_change SEMICOLON",
	"xhpgl_commands : RESET",
	"line_type_change : /* empty */",
	"line_type_change : DIGIT COMMA NUMBER",
	"line_type_change : DIGIT COMMA DIGIT",
	"text_labels : LB",
	"plot_coordinates : PA",
	"plot_coordinates : PD",
	"plot_coordinates : PU",
	"plot_coordinates : PR",
	"scale_coordinates : DIGIT COMMA DIGIT COMMA DIGIT COMMA DIGIT",
	"cordinate_list : /* empty */",
	"cordinate_list : cordinate_list cordinate_def comma_opt",
	"comma_opt : /* empty */",
	"comma_opt : COMMA",
	"cordinate_def : DIGIT COMMA DIGIT",
};
#endif /* YYDEBUG */
/* 
 *	Copyright 1987 Silicon Graphics, Inc. - All Rights Reserved
 */

/* #ident	"@(#)yacc:yaccpar	1.10" */
#ident	"$Revision: 1.9 $"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#ifdef __cplusplus
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( gettxt("uxlibc:78", "syntax error - cannot backup") );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#else
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( gettxt("uxlibc:78", "Syntax error - cannot backup") );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#endif
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yynewmax * sizeof(type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
#ifdef __cplusplus
			yyerror(gettxt("uxlibc:79", "yacc initialization error"));
#else
			yyerror(gettxt("uxlibc:79", "Yacc initialization error"));
#endif
			YYABORT;
		}
	}
#endif

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			int yynewmax, yys_off;

			/* The following pointer-differences are safe, since
			 * yypvt, yy_pv, and yypv all are a multiple of
			 * sizeof(YYSTYPE) bytes from yyv.
			 */
			int yypvt_off = yypvt - yyv;
			int yy_pv_off = yy_pv - yyv;
			int yypv_off = yypv - yyv;

			int *yys_base = yys;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				void *newyys = YYNEW(int);
				void *newyyv = YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
#ifdef __cplusplus
				yyerror( gettxt("uxlibc:80", "yacc stack overflow") );
#else
				yyerror( gettxt("uxlibc:80", "Yacc stack overflow") );
#endif
				YYABORT;
			}
			yymaxdepth = yynewmax;

			/* reset pointers into yys */
			yys_off = yys - yys_base;
			yy_ps = yy_ps + yys_off;
			yyps = yyps + yys_off;

			/* reset pointers into yyv */
			yypvt = yyv + yypvt_off;
			yy_pv = yyv + yy_pv_off;
			yypv = yyv + yypv_off;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
#ifdef __cplusplus
				yyerror( gettxt("uxlibc:81", "syntax error") );
#else
				yyerror( gettxt("uxlibc:81", "Syntax error") );
#endif
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
				/* FALLTHRU */
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 6:
# line 88 "hpgl.y"
{ /* begin select pen */
		 /* set pen color from the SP command */
		 if (is_color)
		   {
		     cur_pen = pen[yypvt[-1].i].pixel; 
		     XSetForeground(dpy, gc, cur_pen); 
		   }
		 } break;
case 10:
# line 100 "hpgl.y"
{ /* begin reset */
		 initialize_plotter();
		 } break;
case 11:
# line 106 "hpgl.y"
{ /* begin solid line */
		   /* set up solid line type */
/*		   line_type = XMakePattern(0xff,8,1); */
		   } break;
case 12:
# line 111 "hpgl.y"
{ /* begin dashed line */
		   /* set up line pattern */
/*		   pat_perc=($3/100.0);
		   tot_dist=sqrt(pow((float)minWidth,(float)2)
				+pow((float)minHeight,(float)2));
		   pat_len=(int)((pat_perc*tot_dist)/8.0);
		   if (pat_len < 1) pat_len = 1;
		   line_type = XMakePattern(line_pattern[$1],8,pat_len);
*/		   } break;
case 13:
# line 121 "hpgl.y"
{ /* begin dashed line */
		   /* set up line pattern */
/*		   pat_perc=($3/100.0);
		   tot_dist=sqrt(pow((float)minWidth,(float)2)
				+pow((float)minHeight,(float)2));
		   pat_len=(int)((pat_perc*tot_dist)/8.0);
		   if (pat_len < 1) pat_len = 1;
		   line_type = XMakePattern(line_pattern[$1],8,pat_len);
*/		   } break;
case 14:
# line 133 "hpgl.y"
{ /* begin plot label */
		 /* plot the text given at the current X,Y locations */
		   text.chars = yypvt[-0].sb;
		   text.nchars = strlen(yypvt[-0].sb);
		   text.delta = 0;
		   text.font = text_font;
		   
		 XDrawText(dpy, main_window, gc, x,y-font_offset, &text, 1);
		 } break;
case 15:
# line 145 "hpgl.y"
{ /* begin pen absolute coordinates */
		   absolute = 1;
		   } break;
case 16:
# line 149 "hpgl.y"
{ /* begin pen relitave coordinates */
		   pen_down = 1;
		   } break;
case 17:
# line 153 "hpgl.y"
{ /* begin pen up coordinates */
		   pen_down = 0;
		   } break;
case 18:
# line 157 "hpgl.y"
{ /* begin pen down coordinates */
		   absolute = 0;
		   } break;
case 19:
# line 163 "hpgl.y"
{ /* begin user scale */
		    /* set up the user coodinate boundaries */
		    xMin = yypvt[-6].i;
		    xMax = yypvt[-4].i;
		    yMin = yypvt[-2].i;
		    yMax = yypvt[-0].i;
                    } break;
case 24:
# line 181 "hpgl.y"
{ /* begin cordinate change */
		 /* get the new x,y points and convert then to absolute
                    X window coodinates based on the user coordinates and 
		    plot scale. */
		 last_x = x;
		 last_y = y;
		 last_offscreen = offscreen;
		 offscreen = 0;

		 if (absolute)
		     { /* begin abs coordinate */
		     x=(double)((yypvt[-2].i - xMin)*(minWidth/(xMax - xMin)));
		     y=(double)((yypvt[-0].i - yMin)*(minHeight/(yMax - yMin)));
		     } /* end abs coordinate */
		 else
		     { /* begin relative coordinate */
		     x=last_x+(double)((yypvt[-2].i - xMin)*(minWidth/(xMax - xMin)));
		     y=last_y+(double)((yypvt[-0].i - yMin)*(minHeight/(yMax - yMin)));
		     } /* end relitave coordinate */

		 /* See if the point is on the screen; if it is not and the last point 
		    was not on the screen, don't paint anything */
		 y = minHeight - y;

		 if (yypvt[-2].i < xMin || yypvt[-2].i > xMax || yypvt[-0].i < yMin && yypvt[-0].i > yMax)
		   offscreen = 1;
		 if (offscreen == 1 && last_offscreen == 1)
		   break;

                 /* if the pen is down, draw a line of the appropriate line
		    type between the last x,y and the current x,y
		    coordinates */
                 if (pen_down)
		     { /* begin draw line */
		     XDrawLine(dpy, main_window, gc, last_x, last_y, x, y);
		     ++span_count;
		     } /* end draw line */
		 } break;
	}
	goto yystack;		/* reset registers in driver code */
}
